"""
[cam.py]
Modulo que utiliza la cam para captar las fotos del cubo.
"""

__author__ = "Victor Ramirez de la Corte"
__date__ = "23/04/2009"
__version__ = "PyRubik v0.6.5"

import pygame
from pygame.locals import *
import sys, os
import opencv
from opencv import highgui 
import colorsys
from language import *
import AnimatedSprite

camera = highgui.cvCreateCameraCapture(0)
def get_image():
    """devuelve la imagen obtenida desde la cam utilizando el modulo opencv"""
    im = highgui.cvQueryFrame(camera)
    im = opencv.cvGetMat(im)
    return opencv.adaptors.Ipl2PIL(im) 


class CapturarDesdeCam:
    """Clase que utiliza la cam para hacer 2 o 6 fotos del cubo, segun elijas"""
    def __init__(self, numMalla = 2):
        fps = 30.0
        pygame.init()
        pygame.display.init()
        window = pygame.display.set_mode((640,480))
        pygame.display.set_caption("PyRubik")
        screen = pygame.display.get_surface()
        if numMalla == 2:
            malla = pygame.image.load("DATOS/malla2.png")
            rutaCubo = "DATOS/cubo.png"

            #me creo una animacion
            animacion = AnimatedSprite.AnimatedSprite(rutaCubo, 5, 12, fps = 12)
            ani = range(12,73,12)
            animacion.rect.center = (300,100)
            animacion.set_animation([0])
            aniCont = 0

            posicionador = pygame.image.load("DATOS/posicionador.png")
            cont = 6
            square = pygame.Rect((0,0), (160,160))
            text = lll.press
            pos = ((0,0),(0,160),(160,160),(320, 160),(480,160),(480,320))
        else:
            malla = pygame.image.load("DATOS/malla1.png")
            cont = 2
            text = lll.press[:lll.press.index(" ")] + " 1(XXL), 2(XL), 3(L)"
            
        font = pygame.font.Font(os.path.join( "FONT", "Times.ttf" ) , 30)
        cut = 0
        
        while 1:
            im = get_image()
            pg_img = pygame.image.frombuffer(im.tostring(), im.size, im.mode)
            pg_img = pygame.transform.flip(pg_img, True, False)
            fuente = font.render(text, True, (255, 255, 0))
            screen.blit(pg_img, (0,0))
            screen.blit(malla, (0,0))
            if numMalla == 2: 
                screen.blit(posicionador, pos[abs(cont-6)])
                #uso la animacion #TODO
                if aniCont < 24:
                    animacion.animate(pygame.time.get_ticks())
                    screen.blit(animacion.image, animacion.rect)
                    aniCont += 1
                    
            screen.blit(fuente, (300,0))
            pygame.display.flip()
            pygame.time.delay(int(1000 * 1.0/fps))
            
            pygame.event.pump()
            keypress = pygame.key.get_pressed()
            
            if keypress[K_RETURN] and numMalla == 2:
                pygame.image.save(pg_img, "capa%d.png" % abs(cont-6))
                animacion.set_animation(range(ani[abs(cont-6)]-12, ani[abs(cont-6)]))
                aniCont = 0
                cont -=1
                if cont <= 0: break
                
            elif (keypress[K_1] or keypress[K_2] or keypress[K_3]) and numMalla != 2:
                if keypress[K_1]: cut = 442     #diametro del circulo
                elif keypress[K_2]: cut = 338
                elif keypress[K_3]: cut = 258
                print cut
                rect1 = pygame.Rect((640-(640-cut)/2, 480-(480-cut)/2), (640, 480))
                rect2 = pygame.Rect((0, 0), (0+(640-cut)/2, 0+(480-cut)/2))
                
                subScreen = pygame.transform.chop(pg_img, rect1)
                subSubScreen = pygame.transform.chop(subScreen, rect2)
                subSubScreen = pygame.transform.flip(subSubScreen, True, False)
                pygame.display.flip()
                pygame.image.save(pg_img, "capa%d.png" % abs(cont-2))
                cont -= 1
                
            if cont <= 0:
                break
