
"""
[cubo.py]
Clase que maneja el cubo en 3D en openGL.
"""

__author__ = "Victor Ramirez de la Corte"
__date__ = "23/04/2009"
__version__ = "PyRubik v0.6.5"

from OpenGL.GL import *
from OpenGL.GLU import *
from OpenGL.GLUT import *
import pygame
from pygame.locals import *
from gameobjects.matrix44 import *
import os, sys, random, math
from texutil import *
from cube_object import *
import GL

class Cube3D:
    def __init__(self):
        if sys.platform == ('win32' or 'win64'):
            os.environ['SDL_VIDEO_CENTERED'] = '1'
        pygame.init()
        screen = [800,600]
        #Si no me equivoco inicia una ventana con OpenGL
        GL.gl_init(*screen)
        x = 0
        pygame.display.set_caption("Pyrubik - Press 'i' for instructions")
        pygame.display.set_icon(pygame.image.load("Images/RubiksCubeIcon.png").convert_alpha())#TODO cambiar icon


    #definimos los ejes o algo asi
    def vec3(self,vec2,axis):
        vec3=[0,0,0]
        if axis[0]!=0:
            vec3[1],vec3[2]=vec2
            vec3[0]=axis[0]+1
        elif axis[1]!=0:
            vec3[0],vec3[2]=vec2
            vec3[1]=axis[1]+1
        elif axis[2]!=0:
            vec3[0],vec3[1]=vec2
            vec3[2]=axis[2]+1
        else: print "ERROR"
        return vec3

    #rotamos los bloques
    def rotate_blocks(self,direction1,direction2,axis):
        self.cube
        block_sequence=((0,0),(1,0),(2,0),(2,1),(2,2),(1,2),(0,2),(0,1))
        block_sequence=block_sequence[::direction1]
        t1=self.cube.sides[self.vec3(block_sequence[0],axis)]
        t2=self.cube.sides[self.vec3(block_sequence[1],axis)]
        x1=self.cube.rotations[self.vec3(block_sequence[0],axis)]
        x2=self.cube.rotations[self.vec3(block_sequence[1],axis)]
        for i in xrange(6):
            self.cube.sides[self.vec3(block_sequence[i],axis)]= \
                self.cube.sides[self.vec3(block_sequence[i+2],axis)]
            self.cube.rotations[self.vec3(block_sequence[i],axis)] = \
                self.cube.rotations[self.vec3(block_sequence[i+2],axis)]
        self.cube.sides[self.vec3(block_sequence[6],axis)]=t1
        self.cube.sides[self.vec3(block_sequence[7],axis)]=t2
        self.cube.rotations[self.vec3(block_sequence[6],axis)]=x1
        self.cube.rotations[self.vec3(block_sequence[7],axis)]=x2
        if axis[0]!=0:
            rot=Matrix44.x_rotation(radians(90.*direction2))
        elif axis[1]!=0:
            rot=Matrix44.y_rotation(radians(90.*direction2))
        elif axis[2]!=0:
            rot=Matrix44.z_rotation(radians(90.*direction2))
        for i in xrange(8):
            self.cube.rotations[self.vec3(block_sequence[i],axis)]=\
                rot*self.cube.rotations[self.vec3(block_sequence[i],axis)]
        self.cube.rotations[self.vec3((1,1),axis)]=\
            rot*self.cube.rotations[self.vec3((1,1),axis)]

    #rotamos las caras
    def rotate_face(self,direction1,direction2,axis):
        if self.animations:
            for a in xrange(0,90*direction2,direction2):
                self.cube.draw(self.rotate[0],self.rotate[1],self.view_distance,self.viewmode,
                          a,axis[0],axis[1],axis[2])
                if self.display_instructions:
                    self.instructions.draw(self.rotate[0],self.rotate[1],self.view_distance)
                pygame.display.flip()
        self.rotate_blocks(direction1,direction2,axis)
        
    #mezclamos, scramble :P
    def shuffle(self):
        self.move_list=[]
        possible_moves="lLrRtTfFbBuU"
        last_s=""
        x = 0
        #esta cambiado para que haga los 25 movimientos oficiales ;)
        while x < 25:
            s=possible_moves[random.randint(0,len(possible_moves)-1)]
            #para que no se repitan las letras, ni las mayusculas tampoco(capitalize)
            if not (s.capitalize()==last_s.capitalize() and s!=last_s):
                self.move_list+=s
                last_s=s
                x += 1

    #entrada de teclas para hacer lo ke te piden, rotar, mover, salir, etc etc        
    def get_input(self):
        for event in pygame.event.get():
            if event.type == QUIT: 
                self.game_running=False
            if event.type == KEYDOWN:
                if event.key==27: 
                    self.game_running=False
                elif event.key==284: # F3 key
                    if self.viewmode == 2.0:
                        while True:
                            self.viewmode -= .03
                            self.cube.draw(self.rotate[0],self.rotate[1],self.view_distance,self.viewmode)
                            if self.display_instructions:
                                self.instructions.draw(self.rotate[0],self.rotate[1],self.view_distance)
                            pygame.display.flip()
                            if self.viewmode < 1.0:
                                break
                    elif self.viewmode == 1.0:
                        while True:
                            self.viewmode += .03
                            self.cube.draw(self.rotate[0],self.rotate[1],self.view_distance,self.viewmode)
                            if self.display_instructions:
                                self.instructions.draw(self.rotate[0],self.rotate[1],self.view_distance)
                            pygame.display.flip()
                            if self.viewmode > 2.0:
                                break
                    if self.viewmode < 1.0: self.viewmode = 1.0
                    elif self.viewmode > 2.0: self.viewmode = 2.0
                elif event.key==K_F4: self.shuffle()
                elif event.key==K_i: self.display_instructions= not self.display_instructions
                elif event.key==K_a: self.animations= not self.animations
                elif event.key==K_F5: self.solving= not self.solving
                elif event.key==K_F6:
                    rot=Matrix44.y_rotation(radians(90.))
                    self.cube.rotations[1,0,0]=rot*self.cube.rotations[1,0,0]
                    for i in xrange(3):
                        for j in xrange(3):
                            for k in xrange(3):
                                print i,j,k,self.cube.sides[i,j,k]
                                print self.cube.rotations[i,j,k]
                else:
                    self.move_list+=event.unicode

        keystate = pygame.key.get_pressed()
        if keystate[K_PAGEUP]: self.view_distance += 0.1
        if keystate[K_PAGEDOWN]: self.view_distance -= 0.1
        if keystate[K_END]: self.view_distance = 9.0;self.rotate[0] = 0.0;self.rotate[1] = 0.0
        if keystate[K_KP4]: self.rotate[1] += 1.0
        if keystate[K_KP6]: self.rotate[1] -= 1.0
        if keystate[K_KP8]: self.rotate[0] += 1.0
        if keystate[K_KP2]: self.rotate[0] -= 1.0

        pressed_mouse=pygame.mouse.get_pressed()
        mickeys=pygame.mouse.get_rel()
        if pressed_mouse[0]:
            self.rotate[0] += mickeys[1]/3.0
            self.rotate[1] += mickeys[0]/3.0
        self.rotate[0]=min(self.rotate[0],45.)
        self.rotate[0]=max(self.rotate[0],-45)
        if self.rotate[1] >= 360: self.rotate[1] = 0
        elif self.rotate[1] <= -360: self.rotate[1] = 0
            
        pygame.event.clear()

    #rotaciones segun el movimiento que hagamos
    def process_next_move(self):
        if len(self.move_list)>0:
            s=self.move_list[0]
            if s=="l":   self.rotate_face(-1,1,(-1,0,0))
            elif s=="L": self.rotate_face(1,-1,(-1,0,0))
            elif s=="t": self.rotate_face(-1,-1,(0,1,0))
            elif s=="T": self.rotate_face(1,1,(0,1,0))
            elif s=="r": self.rotate_face(1,-1,(1,0,0))
            elif s=="R": self.rotate_face(-1,1,(1,0,0))
            elif s=="F": self.rotate_face(-1,1,(0,0,1))
            elif s=="f": self.rotate_face(1,-1,(0,0,1))
            elif s=="b": self.rotate_face(-1,1,(0,0,-1))
            elif s=="B": self.rotate_face(1,-1,(0,0,-1))
            elif s=="u": self.rotate_face(1,1,(0,-1,0))
            elif s=="U": self.rotate_face(-1,-1,(0,-1,0))

            self.move_list=self.move_list[1:]

    from solver import *        

    #clase principal donde inicializamos todo lo que hay que hacer :)        
    def main(self):
        self.instructions=Text_Image("Instructions.png")
        self.rotate = [20.0,20.0,0.0]
        self.view_distance = 9.0
        self.viewmode = 1.0
        self.cube=RubiksCube()
        self.move_list=""
        self.solving=False
        self.animations=True
        self.display_instructions=False
        self.game_running=True
        
        #numero de movimientos necesarios para resolver el cubo
        #lo flipo, mas de 200 movimientos :O
        w = 0

        #bucle del juego
        while self.game_running: # para salirse del juego
            self.get_input()
            self.process_next_move()
            if self.solving and len(self.move_list)==0:
                self.move_list += solver(self.cube)
                #contador de movimientos
                w += len(solver(self.cube))
                if len(self.move_list)==0: self.solving=False    
            self.cube.draw(self.rotate[0],self.rotate[1],self.view_distance,self.viewmode)
            if self.display_instructions:
                self.instructions.draw(self.rotate[0],self.rotate[1],self.view_distance)
            pygame.display.flip()
        pygame.quit()




