#!/usr/bin/env python
#-*- coding: iso-8859-15 -*-

"""
[menu.py]
Clase principal que ejecuta el programa en entorno gráfico.
"""

__author__ = "Victor Ramirez de la Corte"
__date__ = "23/04/2009"
__version__ = "PyRubik v0.6.5"


import pygame, sys, os
from language import *
from pygame.locals import *
from scramble import *
from timer import *
import capturar
import timer
import cubo
import cam
import bd
#import cube3D


def load_image(folder, name):
    fullname = os.path.join(folder, name)
    image = pygame.image.load(fullname)
    image = image.convert_alpha()
    return image


def insertStringInBackground(cadena, font, color, background, window, pos = (0,0), update = None):            
    """
    Insertar una cadena en pygame.
    cadena: string que quieres insertar
    font: font de pygame
    color: rgb(r,g,b)
    backgroung: imagen de fondo
    window = ventana en la que quieres escribir
    pos: posicion en la que quieres colocar el texto
    update: tipo rect el cual es el que se actualiza 
    """
    fuente = font.render(cadena, True, color)
    window.blit(background, (0,0))
    window.blit(fuente, pos)
    pygame.display.update(update)
    

def captureKeys(cadena, font, color, background, window, pos = (0,0),update = None):
    """
    Capturamos keys desde pygame e insertamos la captura en pygame.
    cadena: string que quieres insertar
    font: font de pygame
    color: rgb(r,g,b)
    backgroung: imagen de fondo
    window = ventana en la que quieres escribir
    pos: posicion en la que quieres colocar el texto
    update: tipo rect el cual es el que se actualiza
    """
    pygame.event.clear()
    string = ""
    while 1:
        insertStringInBackground(cadena + string, font, color, background, window, pos, update)
        keys = pygame.event.wait()
        if keys.type == KEYDOWN and keys.key == K_BACKSPACE:
            string = string[:len(string)-1]
        elif keys.type == KEYDOWN and keys.key == K_RETURN:
            break
        elif keys.type == KEYDOWN and keys.key == K_ESCAPE:
            string = ""
            break
        elif keys.type == KEYDOWN and keys.key == K_SPACE:
            string += " "
        elif keys.type == KEYDOWN:
            key = keys.key
            string += pygame.key.name(key)
    pygame.event.clear()
    return string


def pintarCubo(window, capas, numberOrColor = 1,  colores = None):#TODO fallo de segmentacion
    """pinta las capas de self.capas con pygame"""
    #variables
    m = (95, 95, 95, 190, 285, 0)
    n = (0, 95, 190, 95, 95, 95)
    a = (0, 30, 60)
    
    #recorremos todos los colores captados para pintarlo en pantalla
    for x in range(len(capas)):
        for w in range(len(capas[x])): #TODO
            if numberOrColor == 0:  #pinta por num
                pygame.draw.rect(window, colores[int(capas[x][w])][2],\
                 (a[w%3]+m[x], a[w//3]+n[x], 30, 30))
            else:   #pinta por colores
                pygame.draw.rect(window, capas[x][w], (a[w%3]+m[x], a[w//3]+n[x], 30, 30))

"""
def opcionesThemes(themes):
    archivo = open("theme/%s/opt.txt" % themes, "r")
    opc = archivo.readlines()
    
    color = opc[0][opc[0].index("=")+1:opc[0].index("\n")]
    colorSel = opc[1][opc[1].index("=")+1:opc[1].index("\n")]
    sizeFont = opc[2][opc[2].index("=")+1:opc[2].index("\n")]
    sizeFontScr = opc[3][opc[3].index("=")+1:opc[3].index("\n")]
    sizeFontClock = opc[4][opc[4].index("=")+1:opc[4].index("\n")]
    center = opc[5][opc[5].index("=")+1:opc[5].index("\n")]
    pos = opc[5][opc[5].index("=")+1:opc[5].index("\n")]
    return color, colorSel, sizeFont, sizeFontClock, center, pos
"""

class Menu:

    def __init__(self, size=(800, 600), sizeFont = 40, sizeFontScr = 20,\
         color = (255,155,0), colorSel = (0, 255, 0),\
          pos=(300, 200, 50), center=False, theme=0, lang = 0):
        
        #TODO controlar mejor los eventos para que el programa funciones mejor
        #inicializamos font y display
        pygame.font.init()

        self.window = pygame.display.set_mode(size)
        pygame.display.set_caption("PyRubik")
        pygame.display.set_icon(load_image("DATOS", "icon.png"))
        themes = os.listdir('themes')
        themes.sort()
        #themes = themes[1:]
        font = "themes/%s" % themes[theme]
        background = "themes/%s" % themes[theme]
        self.background = load_image(background, "background.png")
        self.font = pygame.font.Font(os.path.join(font, "font.ttf") , sizeFont)
        self.fontScr = pygame.font.Font(os.path.join(font, "font.ttf") , sizeFontScr)
        self.fontTime = pygame.font.Font(os.path.join(font, "font.ttf") , 80)
        self.window.blit(self.background, (0,0))
        self.options = lll.menu[:]
        self.options[5] = self.options[5].partition("<")[0] + "<%s>" % themes[theme]
        idiomas = os.listdir('mo')[:]
        idiomas.sort()
        #idiomas = idiomas[1:]

        #Creamos un reloj
        reloj = pygame.time.Clock()

        #variable opt --> opcion, l--> lenguaje ej: si l = 1 --> idioma es ingles
        opt = 0
        l = 1
        cont = 0

        while 1:
            #inicializar teclas y actualizar
            pygame.display.flip()
            noWait = pygame.event.pump()
            keyinput = pygame.key.get_pressed()
            if self.window.get_size() != (size):
                self.window = pygame.display.set_mode(size)
                
                                            
            #Nos creamos las Surface de texto
            outMenu = []
            for k in range(len(self.options)):
                if opt == k:
                    outMenu.append(self.font.render(self.options[k], True, colorSel))
                else:
                    outMenu.append(self.font.render(self.options[k], True, color))
                self.window.blit(outMenu[k], (pos[0], pos[1] + k*pos[2]))
            
            #pintar fondo y opciones de menu
            self.window.blit(self.background, (0,0))
            for z in range(len(outMenu)):
                #opciones centradas o no
                if center == True:
                    f_rect = outMenu[z].get_rect()
                    f_rect.move_ip(pos[0], pos[1] + z*pos[2])
                    f_rect.centerx = self.window.get_rect().centerx
                else:
                    #TODO falla, mirar cuando kieras 
                    f_rect = (pos[0], pos[1] + z*pos[2])
                self.window.blit(outMenu[z], f_rect)
            
            #cambiar theme
            if opt == 5 and (keyinput[K_RIGHT] or keyinput[K_LEFT]):
                if keyinput[K_RIGHT]:
                    theme += 1
                    if theme  > len(themes) - 1:
                        theme = 0
                elif keyinput[K_LEFT]:
                    theme -= 1
                    if theme < 0:
                        theme = len(themes) - 1 
                
                self.options = lll.menu[:]
                self.options[5] = self.options[5].partition("<")[0] + "<%s>" % themes[theme]
                font = "themes/%s/font.ttf" % themes[theme]
                background = "themes/%s/background.png" % themes[theme]
                mmm = Menu(color=(255,155,0,155), theme = theme, lang = lang)
                
            #cambiar idioma
            if (keyinput[K_RIGHT] or keyinput[K_LEFT]) and opt == 3 or lang == 0:
                event = pygame.event.wait()
                if event.type == KEYDOWN and keyinput[K_LEFT]:
                    l -= 1
                    if l < 0:
                        l = len(idiomas) - 1
                elif event.type == KEYDOWN and keyinput[K_RIGHT]:
                    l += 1
                    if l > len(idiomas) - 1:
                        l = 0
                lll.translate(idiomas[l])
                self.options = lll.menu
                self.options[5] += "<%s>" % themes[theme]
                for k in range(len(self.options)):
                    outMenu.insert(k, (self.font.render(self.options[k], True, color)))
                    self.window.blit(outMenu[k], (pos[0], pos[1] + k*pos[2]))
                outMenu = outMenu[:len(self.options)]
                lang = 1
                reloj.tick(100)
                pygame.time.delay(30)

            #movernos en el menu
            if keyinput[K_DOWN] or keyinput[K_UP]:
                event = pygame.event.wait()
                if event.type == KEYDOWN and keyinput[K_DOWN]:
                    opt += 1
                    if opt >= len(self.options):
                        opt = 0
                elif event.type == KEYDOWN and keyinput[K_UP]:
                    opt -= 1
                    if opt < 0:
                        opt = len(self.options)-1  
            

            #entrar en la opcion seleccionada
            #TEMPORIZADOR
            if keyinput[K_RETURN] and opt == 0:  
                alg = Scramble()
                scra = self.fontScr.render("Scramble: "+alg.scramble(), True, color)
                self.window.blit(self.background, (0,0))
                self.window.blit(scra, (20,250))
                pygame.display.update()
                
                #capturamos el tiempo de espera, defecto: 5 seg
                string = captureKeys(lll.insertEsp, self.fontScr,\
                 color, self.background, self.window, (20,300), update=((20,300),(760,20)))
                stringT = string
                try: string = int(string)
                except: string = 5
                
                while 1:
                    #mostrar opciones
                    self.window.blit(self.background, (0,0))
                    insertStringInBackground(lll.cadenaMenu[0], self.fontScr, color,\
                     self.background, self.window, pos=(20,350), update=((20,350),(760,40)))
                    insertStringInBackground(lll.cadenaMenu[1], self.fontScr, color,\
                     self.background, self.window, pos=(20,400), update=((20,400),(760,40)))

                    evento5 = pygame.event.wait()
                    if evento5.type == KEYDOWN and (evento5.key == K_RETURN or evento5.key == K_SPACE): 
                        #cronometramos la espera 
                        for st in range(string, 0, -1):
                            insertStringInBackground(str(st), self.fontTime, color,\
                             self.background, self.window, pos=(350,500), update=((350,500),(350,80)))
                            time.sleep(1)
                        tim = time.time()
                        tempX = 0
                        pygame.event.clear()
                        
                        #cronometro del tiempo
                        while not tempX:
                            tiempo = time.time() - tim
                            tiempoStr = str(tiempo)
                            posP =  tiempoStr.index(".")
                            cadenaTime = tiempoStr[:posP] + tiempoStr[posP:posP+3]
                            cadT = self.fontTime.render(cadenaTime, True, color)
                            self.window.blit(self.background, (0,0))
                            self.window.blit(cadT, (350,500))
                            pygame.display.update(((350,500),(350,80)))
                            pygame.event.pump()
                            keyinput = pygame.key.get_pressed()    
                            tempX = keyinput[K_SPACE]
                            #fps
                            reloj.tick(100)
                            pygame.time.delay(30)
                            #print reloj.get_fps() #obtener los fps
                        pygame.event.clear()
                        #TODO TODO aqui me keao
                        #guardar en la base de datos preguntando antes
                        save = captureKeys(lll.save + ": ", self.fontScr, color,\
                         self.background, self.window, pos = (20,400), update=((20,400),(760,20)))
                        if lll.yes.count(save.lower()) > 0:
                            bbdd = bd.BD()
                            bbdd.guardar(tiempo, "3x3x3")
                            bbdd.close()
                            insertStringInBackground(lll.saved, self.font,\
                             color, self.background, self.window, pos = (100,350))                        
                        scra = self.fontScr.render("Scramble: "+alg.scramble(), True, color)
                        self.window.blit(self.background, (0,0))
                        self.window.blit(scra, (20,250))
                        pygame.display.update((20,250),(760,20))
                        
                    elif evento5.type == KEYDOWN and evento5.key == K_ESCAPE:
                        break
                    

            #SOLUCIONAR
            if keyinput[K_RETURN] and opt == 2:
                pass
                #pasar a hsl y sacar 
                #captura.rgbToHls()
                #captura.encontrarBlancos()
                #coloresMedios = captura.coloresMedios()
                #print coloresMedios
                #captura.setColores(coloresMedios)
                #el color esta en h , ahi que pasarlo a rgb pa poerlo pintá
                #comenzamos a resolver
                #resolver = solve.Solve(captura.getCapas())
                #resolver.CruzPrimeraCapa(int(raw_input("\n\r0.Blanco\n\r1.Amarilla\
                #\n\r2.Naranja\n\r[3.Azul]\n\r4.Verde\n\r5.Rojo")))#TODO colores con idiomas
            
            
            #CAPTURAR COLORES                        
            elif keyinput[K_RETURN] and opt == 1: 
                captura = capturar.Capturar()
                cadena = "(1).[" + lll.optSolve[1] + "], (2)." + lll.optSolve[0]
                cadenaFont = self.fontScr.render(cadena, True, color)
                self.window.blit(self.background, (0,0))
                self.window.blit(cadenaFont, (0,300))
                pygame.display.update()
                #elegir si manual, con cam, 3D
                while 1:
                    event2 = pygame.event.wait()
                    if event2.type == KEYDOWN and event2.key == K_1:
                        paleta12 = pygame.image.load("DATOS/paleta12.png")
                        cubo2D = pygame.image.load("DATOS/cube2D.png")
                        break
                    elif event2.type == KEYDOWN and event2.key == K_ESCAPE:
                        pygame.event.clear()
                        break
                    elif event2.type == KEYDOWN and event2.key == K_2:
                        break    
                
                if event2.key == K_1:
                    self.window.blit(self.background, (0,0))
                    insertStringInBackground(lll.finish, self.fontScr, color,\
                     self.background, self.window, pos=(50,550))
                    self.window.blit(paleta12, (20,290))
                    self.window.blit(cubo2D, (400,300))
                    #variables
                    xPos = (492, 492, 492, 582, 672, 402)#m
                    yPos = (302, 392, 482, 392, 392, 392)#n
                    subPos = (0, 30, 60)#a
                    posCentros = (4,13,22,31,40,49)
                    selColor = (255,255,255)
                    colorCentro = set()
                    rects = [[],[]]
                    #recorremos todos los colores captados para pintarlo en pantalla
                    for x in range(6):
                        for w in range(9):
                            rects[0].append(pygame.Rect((subPos[w%3]+xPos[x],subPos[w//3]+yPos[x]),(26,26)))
                            rects[1].append((0,0,w+1))
                    pygame.display.update()
                    
                    while 1:
                        click = pygame.event.wait()
                        if click.type == MOUSEBUTTONDOWN:
                            mousePos = pygame.mouse.get_pos()
                            if (20 <= mousePos[0] <= 220) and (290 <= mousePos[1] <= 440):
                                selColor = self.window.get_at(pygame.mouse.get_pos())
                                print "Color: ",selColor
                            elif (400 <= mousePos[0] <= 760) and (300 <= mousePos[1] <= 570):
                                for rect in rects[0]:
                                    if (rect[0] <= mousePos[0] <= (rect[0] + rect[2]))\
                                     and (rect[1] <= mousePos[1] <= (rect[1] + rect[3])):
                                        pygame.draw.rect(self.window, selColor, rect)
                                        numColoresUsados = rects[1].count(selColor)
                                        print numColoresUsados
                                        
                                        if numColoresUsados < 9:
                                            rects[1][rects[0].index(rect)] = selColor
                                            pygame.display.update(rect)
                                        else:
                                            print "hay mas de nueve colores ya"
                            #elif (50 <= mousePos[0] <= 400) and (550 <= mousePos[1] <= 570):
                            #    break
                        if click.type == KEYDOWN and click.key == K_RETURN:
                            break
                    cont = 0
                    self.capas = [[],[],[],[],[],[]]
                    for xx in range(6):
                        for yy in range(9):
                            self.capas[xx].append(rects[1][cont])
                            cont += 1
                    print self.capas
                        
                            
                    """
                    #TODO USAR FOTO DE CUBO CON NUMEROS Y MIRAR SI SE PUEDEN UNIR MAIN Y MENU                        
                    cont = 0
                    for capas in captura.capas:
                        for cara in range(6):
                            cadenaCol = captura.colores[cara][0] + str(captura.colores[cara][1])
                            insertStringInBackground(cadenaCol, self.fontScr,
                             color, self.background, self.window, (20,250+cara*25),\
                              update = ((20,250+cara*25),(760,20)))

                        apto = False
                        string = ""
                        colorComprueba = (0,255,0)
                        while not apto and cont <= 6:
                            insertStringInBackground(lll.insertColor+": "+string,\
                             self.fontScr,colorComprueba, self.background,\
                              self.window, (300,250+cont*25),\
                               update = ((300,250+cont*25),(400,20)))
                            keys = pygame.event.wait()
                            if keys.type == KEYDOWN and keys.key == K_BACKSPACE:
                                string = string[:len(string)-1]
                            elif keys.type == KEYDOWN and keys.key == K_RETURN:
                                #añadiendo colores
                                if len(string) == 9 and colorComprueba == (0,255,0):
                                    for numColor in string:  
                                        captura.colores[int(numColor)][1] -=1
                                        cadenaColor = captura.colores[int(numColor)][0]
                                        capas.append(int(cadenaColor[0]))
                                    apto = True
                                    cont += 1
                            elif keys.type == KEYDOWN and keys.key == K_ESCAPE:
                                string = ""
                                break
                            elif keys.type == KEYDOWN and keys.key == K_SPACE:
                                string += " "
                            elif keys.type == KEYDOWN:
                                key = keys.key
                                string += pygame.key.name(key)
                            #comprobamos los colores
                            existe = False
                            for caracter in range(len(string)):
                                for contColor in range(6):
                                    if string[caracter] == str(contColor):
                                        existe = existe+True
                            for contColor in range(5):
                                print (captura.colores[contColor][1]-string.count(str(contColor))) < 0
                                if ((captura.colores[contColor][1]-string.count(str(contColor))) < 0) or\
                                 string.isdigit() == False or not existe or len(string)>9: 
                                    colorComprueba = (255,0,0)            
                                else: colorComprueba = (0,255,0)
                        pygame.event.clear()
                    """
                    
                
                if event2.key == K_2:
                    cadena = "(1).[2 " + lll.fotos + "] u (2). 6 " + lll.fotos + "  3. usar import cube3D"
                    cadenaFont = self.fontScr.render(cadena, True, color)
                    self.window.blit(self.background, (0,0))
                    self.window.blit(cadenaFont, (0,300))
                    pygame.display.update()
                    pygame.event.clear()
                    while 1: 
                        pygame.event.clear()
                        event3 = pygame.event.wait()
                        if event3.type == KEYDOWN and event3.key == K_1:
                            malla = 1
                            break
                        elif event3.type == KEYDOWN and event3.key == K_ESCAPE:
                            pygame.event.clear()
                            break
                        elif event3.type == KEYDOWN and event3.key == K_2:
                            malla = 2
                            break
                        elif event3.type == KEYDOWN and event3.key == K_3:
                            cubo3D = cubo.Cube3D()
                            cubo3D.main()
                    if event3.key != K_ESCAPE:
                        cam.CapturarDesdeCam(malla)
                        if event3.key == K_2:
                            captura.capturarColores6Capas()
                        else:
                            captura.sacarColoresDeImagen()
                        ColorOrNumber = 1
                    

            #STATISTIC
            elif keyinput[K_RETURN] and opt == 4: 
                bbdd = bd.BD()
                self.window.blit(self.background, (0,0))
                pygame.display.update()
                
                for intSta in range(len(lll.statistic)):
                    insertStringInBackground(lll.statistic[intSta], self.fontScr,
                     color, self.background, self.window, (20,250+intSta*25),\
                      update = ((20,250+intSta*25),(760,20)))
                
                pygame.event.clear()
                otraConsulta = True
                while otraConsulta:
                    mostrar = False
                    event4 = pygame.event.wait()
                    if event4.type == KEYDOWN and event4.key == K_2:
                        media = captureKeys("Average of: ", self.fontScr,\
                         color, self.background, self.window, (40,400),\
                          update=((40,400),(760,20)))
                        try: media = int(media)
                        except: media = 5
                        consultaStr = bbdd.consultarMediaDe(media)
                        mostrar = True
                    elif event4.type == KEYDOWN and event4.key == K_3: 
                        consultaStr = bbdd.consultarRecord()
                        mostrar = True
                    elif event4.type == KEYDOWN and event4.key == K_4:
                        tipo = captureKeys("Tipo: ", self.fontScr,\
                         color, self.background, self.window, (40,400),\
                          update=((40,400),(760,20)))
                        consultaStr = bbdd.consultarTiemposDe(str(tipo))
                        mostrar = True
                    elif event4.type == KEYDOWN and event4.key == K_1:
                        consultaStr = bbdd.consultarTodo()
                        mostrar = True
                    elif event4.type == KEYDOWN and event4.key == K_ESCAPE:
                        break
                    
                    if mostrar: 
                        insertStringInBackground(consultaStr,\
                         self.fontScr,color, self.background, self.window,\
                          (40,400),update = ((40,400),(760,20)))
                        insertStringInBackground(lll.consulta, self.fontScr,\
                         color, self.background, self.window, (40,450),\
                          update=((40,450),(760,20)))
                        
                        v = pygame.locals
                        while 1:
                            event4 = pygame.event.wait()
                            if event4.type == KEYDOWN and (event4.key == \
                             getattr(v, 'K_%s' % lll.no[1]) or event4.key == K_ESCAPE ):
                                otraConsulta = False
                                break
                            elif event4.type == KEYDOWN and event4.key == getattr(v, 'K_%s' % lll.yes[1]):
                                otraConsulta = True 
                                self.window.blit(self.background, (0,0))
                                pygame.display.update(((40,400),(760,100)))
                                break
                            reloj.tick(100)
                            pygame.time.delay(30)
                bbdd.close()
                pygame.event.clear()
                
                             
            #CREDITOS
            elif keyinput[K_RETURN] and opt == 6: 
                self.window.blit(self.background, (0,0))
                pygame.display.update()
                
                for intCre in range(len(lll.credits)):
                    insertStringInBackground(lll.credits[intCre], self.fontScr,
                     color, self.background, self.window, (20,250+intCre*40),\
                      update = ((20,250+intCre*40),(760,40)))
                
                x = False
                while not x:
                    event = pygame.event.wait()
                    x = (event.type == KEYDOWN and event.key == K_ESCAPE)
                
            #SALIR
            elif keyinput[K_RETURN] and opt == 7: 
                sys.exit()
   
            #fullscreen
            if keyinput[K_f]:
                pygame.display.toggle_fullscreen()
            #fps
            reloj.tick(100)
            pygame.time.delay(30)
                
mmm = Menu()

